/**
 * Copyright (c) 2000-2013 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.tref.liferay.mapit.map.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.impl.BaseModelImpl;

import it.tref.liferay.mapit.map.service.ClpSerializer;
import it.tref.liferay.mapit.map.service.PluginLocalServiceUtil;

import java.io.Serializable;

import java.lang.reflect.Method;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @author $author$
 */
public class PluginClp extends BaseModelImpl<Plugin> implements Plugin {
	public PluginClp() {
	}

	@Override
	public Class<?> getModelClass() {
		return Plugin.class;
	}

	@Override
	public String getModelClassName() {
		return Plugin.class.getName();
	}

	@Override
	public long getPrimaryKey() {
		return _pluginId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setPluginId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _pluginId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		attributes.put("pluginId", getPluginId());
		attributes.put("createDate", getCreateDate());
		attributes.put("modifiedDate", getModifiedDate());
		attributes.put("name", getName());
		attributes.put("version", getVersion());
		attributes.put("mapItVersion", getMapItVersion());
		attributes.put("context", getContext());
		attributes.put("active", getActive());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Long pluginId = (Long)attributes.get("pluginId");

		if (pluginId != null) {
			setPluginId(pluginId);
		}

		Date createDate = (Date)attributes.get("createDate");

		if (createDate != null) {
			setCreateDate(createDate);
		}

		Date modifiedDate = (Date)attributes.get("modifiedDate");

		if (modifiedDate != null) {
			setModifiedDate(modifiedDate);
		}

		String name = (String)attributes.get("name");

		if (name != null) {
			setName(name);
		}

		String version = (String)attributes.get("version");

		if (version != null) {
			setVersion(version);
		}

		String mapItVersion = (String)attributes.get("mapItVersion");

		if (mapItVersion != null) {
			setMapItVersion(mapItVersion);
		}

		String context = (String)attributes.get("context");

		if (context != null) {
			setContext(context);
		}

		Boolean active = (Boolean)attributes.get("active");

		if (active != null) {
			setActive(active);
		}
	}

	@Override
	public long getPluginId() {
		return _pluginId;
	}

	@Override
	public void setPluginId(long pluginId) {
		_pluginId = pluginId;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setPluginId", long.class);

				method.invoke(_pluginRemoteModel, pluginId);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public Date getCreateDate() {
		return _createDate;
	}

	@Override
	public void setCreateDate(Date createDate) {
		_createDate = createDate;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setCreateDate", Date.class);

				method.invoke(_pluginRemoteModel, createDate);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	@Override
	public void setModifiedDate(Date modifiedDate) {
		_modifiedDate = modifiedDate;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setModifiedDate", Date.class);

				method.invoke(_pluginRemoteModel, modifiedDate);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getName() {
		return _name;
	}

	@Override
	public void setName(String name) {
		_name = name;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setName", String.class);

				method.invoke(_pluginRemoteModel, name);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getVersion() {
		return _version;
	}

	@Override
	public void setVersion(String version) {
		_version = version;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setVersion", String.class);

				method.invoke(_pluginRemoteModel, version);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getMapItVersion() {
		return _mapItVersion;
	}

	@Override
	public void setMapItVersion(String mapItVersion) {
		_mapItVersion = mapItVersion;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setMapItVersion", String.class);

				method.invoke(_pluginRemoteModel, mapItVersion);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public String getContext() {
		return _context;
	}

	@Override
	public void setContext(String context) {
		_context = context;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setContext", String.class);

				method.invoke(_pluginRemoteModel, context);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	@Override
	public boolean getActive() {
		return _active;
	}

	@Override
	public boolean isActive() {
		return _active;
	}

	@Override
	public void setActive(boolean active) {
		_active = active;

		if (_pluginRemoteModel != null) {
			try {
				Class<?> clazz = _pluginRemoteModel.getClass();

				Method method = clazz.getMethod("setActive", boolean.class);

				method.invoke(_pluginRemoteModel, active);
			}
			catch (Exception e) {
				throw new UnsupportedOperationException(e);
			}
		}
	}

	public BaseModel<?> getPluginRemoteModel() {
		return _pluginRemoteModel;
	}

	public void setPluginRemoteModel(BaseModel<?> pluginRemoteModel) {
		_pluginRemoteModel = pluginRemoteModel;
	}

	public Object invokeOnRemoteModel(String methodName,
		Class<?>[] parameterTypes, Object[] parameterValues)
		throws Exception {
		Object[] remoteParameterValues = new Object[parameterValues.length];

		for (int i = 0; i < parameterValues.length; i++) {
			if (parameterValues[i] != null) {
				remoteParameterValues[i] = ClpSerializer.translateInput(parameterValues[i]);
			}
		}

		Class<?> remoteModelClass = _pluginRemoteModel.getClass();

		ClassLoader remoteModelClassLoader = remoteModelClass.getClassLoader();

		Class<?>[] remoteParameterTypes = new Class[parameterTypes.length];

		for (int i = 0; i < parameterTypes.length; i++) {
			if (parameterTypes[i].isPrimitive()) {
				remoteParameterTypes[i] = parameterTypes[i];
			}
			else {
				String parameterTypeName = parameterTypes[i].getName();

				remoteParameterTypes[i] = remoteModelClassLoader.loadClass(parameterTypeName);
			}
		}

		Method method = remoteModelClass.getMethod(methodName,
				remoteParameterTypes);

		Object returnValue = method.invoke(_pluginRemoteModel,
				remoteParameterValues);

		if (returnValue != null) {
			returnValue = ClpSerializer.translateOutput(returnValue);
		}

		return returnValue;
	}

	@Override
	public void persist() throws SystemException {
		if (this.isNew()) {
			PluginLocalServiceUtil.addPlugin(this);
		}
		else {
			PluginLocalServiceUtil.updatePlugin(this);
		}
	}

	@Override
	public Plugin toEscapedModel() {
		return (Plugin)ProxyUtil.newProxyInstance(Plugin.class.getClassLoader(),
			new Class[] { Plugin.class }, new AutoEscapeBeanHandler(this));
	}

	@Override
	public Object clone() {
		PluginClp clone = new PluginClp();

		clone.setPluginId(getPluginId());
		clone.setCreateDate(getCreateDate());
		clone.setModifiedDate(getModifiedDate());
		clone.setName(getName());
		clone.setVersion(getVersion());
		clone.setMapItVersion(getMapItVersion());
		clone.setContext(getContext());
		clone.setActive(getActive());

		return clone;
	}

	@Override
	public int compareTo(Plugin plugin) {
		int value = 0;

		value = getContext().compareTo(plugin.getContext());

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof PluginClp)) {
			return false;
		}

		PluginClp plugin = (PluginClp)obj;

		long primaryKey = plugin.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public String toString() {
		StringBundler sb = new StringBundler(17);

		sb.append("{pluginId=");
		sb.append(getPluginId());
		sb.append(", createDate=");
		sb.append(getCreateDate());
		sb.append(", modifiedDate=");
		sb.append(getModifiedDate());
		sb.append(", name=");
		sb.append(getName());
		sb.append(", version=");
		sb.append(getVersion());
		sb.append(", mapItVersion=");
		sb.append(getMapItVersion());
		sb.append(", context=");
		sb.append(getContext());
		sb.append(", active=");
		sb.append(getActive());
		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		StringBundler sb = new StringBundler(28);

		sb.append("<model><model-name>");
		sb.append("it.tref.liferay.mapit.map.model.Plugin");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>pluginId</column-name><column-value><![CDATA[");
		sb.append(getPluginId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>createDate</column-name><column-value><![CDATA[");
		sb.append(getCreateDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
		sb.append(getModifiedDate());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>name</column-name><column-value><![CDATA[");
		sb.append(getName());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>version</column-name><column-value><![CDATA[");
		sb.append(getVersion());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>mapItVersion</column-name><column-value><![CDATA[");
		sb.append(getMapItVersion());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>context</column-name><column-value><![CDATA[");
		sb.append(getContext());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>active</column-name><column-value><![CDATA[");
		sb.append(getActive());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _pluginId;
	private Date _createDate;
	private Date _modifiedDate;
	private String _name;
	private String _version;
	private String _mapItVersion;
	private String _context;
	private boolean _active;
	private BaseModel<?> _pluginRemoteModel;
}